/*
pdemo.c - demo programm for Palantir
Version : 0.3
Copyright 1997 Dim Zegebart, Moscow Russia.
E-mail zager@post.comstar.ru
http://www.geocities.com/siliconvalley/pines/7817
Tel. in Moscow (095)9560389
Fax. in Moscow (095)9563540
*/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <palantir.h>
#include <io.h>
#include "pdemo.cfg"

inline void dz_print_comm_err() {printf("%s",szDZCommErr);fflush(stdout);}

device *port1; //mouse
device *port2; //modem
//device *cur_port;

int keyboard_handler(a_message code,int p1,int p2);

//--------------------- ONE OF IDLE PROC ---------------------

int show_time(void)
{ struct time now;
  int tmp;
  static int prev_time=59;
  int x,y;

  real_time_clock(0,&now);
  if (prev_time==now.ti_sec) return(1);
  prev_time=now.ti_sec;

  #ifdef __GRX_MODE__
  { char s[20];
    lwp_disable;
    sprintf(s,"%d:%d:%d    ",now.ti_hour,now.ti_min,now.ti_sec);
    show_mouse(NULL);
    textout(screen,font,s,700,20,255);
    show_mouse(screen);
    lwp_enable;
  }
  #else
  {
    lwp_disable;
    x=wherex();
    y=wherey();
    gotoxy(70,1);
    printf("%d:%d:%d   \n",now.ti_hour,now.ti_min,now.ti_sec);
    gotoxy(x,y);
//    printf("%d\n",time(0));
    lwp_enable;
  }
  #endif

  return(1);
}

#ifdef __GRX_MODE__
//------------------ LOAD PAL --------------------
BITMAP *pcx;

RGB *load_pal(char *file_name)
{ FILE *hIn=fopen(file_name,"rt");
  long l,n;
  char *hBufIn,*s;
  RGB *pal=(RGB*)malloc(sizeof(RGB)*256);

  if (hIn==NULL) return(NULL);
  l=filelength(fileno(hIn));
  if ((hBufIn=(char*)alloca(l))==NULL) return(NULL);

//get general stat data
  l=fread(hBufIn,1,l,hIn);
  fclose(hIn);
  s=hBufIn;
  hBufIn[l]=0;

  n=0;
  while (strlen(s)>3)
   { sscanf(s,"%d %d %d\n",(int*)&pal[n].r,(int*)&pal[n].g,(int*)&pal[n].b);
     n++;
     s=(char*)strchr(s,'\n')+1;
   }
  return(pal);
}

void set_screen(void)
{
   RGB *pal;

   pal=load_pal("valinor.pal");
//   allegro_init();
   set_gfx_mode(GFX_AUTODETECT, 800, 600, 0, 0);

   if ((pcx=load_pcx("valinor.pcx",pal))==NULL) exit(3);
   set_pallete((PALLETE*)pal);
   blit (pcx,screen,0,0,0,0,800,600);

   blit (pcx,screen,0,0,0,0,800,600);
//   blit (pcx,gui_screen,0,0,SCREEN_W,SCREEN_H,800,600);
   show_mouse(screen);

//   textout_centre(screen, font, "Hello, world!", SCREEN_W/2, SCREEN_H/2, 255);
}
#endif

void foo(void)
{ //int x,y;
  int x,y,i=0;
  int tmp;
  while(1)
   { i++;
     lwp_disable;
     x=wherex();
     y=wherey();
//     gotoxy(65,1);
//     putch(i-1);
//     gotoxy(x,y);
//     putch('m');
//     printf("T %d \n",tick_counter);
     lwp_enable;
     lwp_yield();
   }
}


#ifdef __DZ_COMM_LWP__
int com2_wrapper(void)
{ int tmp;
  lwp_disable;
  dz_comm_port_interrupt_handler(port2);
  lwp_enable;
  return(0);
}
END_OF_FUNCTION(com2_wrapper);

int com2_handler(a_message code,int p1,int p2)
{ int tmp; //variable used by lwp_enable(disable) macros

  switch(code)
   { case APP_START:
      break;
     case H_COMM_IN:
      if (p1==0) p1=' ';
      lwp_disable;
      putch(p1);
      //printf("%d\n",p1);
      lwp_enable;
      break;
     case APP_STOP:
      return(0);
      break;
     default:
      break;
   }

 return(1);
}

#endif

#ifdef __DZ_COMM_LWP__
int com1_wrapper(void)
{ dz_comm_port_interrupt_handler(port1);
  return(0);
}
END_OF_FUNCTION(com1_wrapper);

int com1_handler(a_message msg,int p1,int p2)
{
  putch(p1);
  return(1);
}
#endif

#ifdef __DZ_KEYBOARD_LWP__
int keyboard_handler(a_message code,int p1,int p2)
{ int tmp;
  int c=p1;
  byte ch;

//  printf("Code : %d\n",code);

  if (code==H_KEYBOARD)
   { if (ctrl_(c,'Q'))
      { //device_put(system_device,M_STOP); //stop messaging, exit programm
        palantir_deinit();
        return(1);
      }

     ch=ascii_(c);
     lwp_disable;
     putch(ch);
     lwp_enable;
     #ifdef __DZ_COMM_LWP__
     comm_port_out(port2,ch);
     #endif
   }
   //  device_put(port2,ch);
  return(1);
}
#endif

#ifdef __DZ_MOUSE_LWP__
int mouse_handler(a_message code,int p1,int p2)
{ int c=p1;
  int x,y,b;
  int tmp;
//  c=device_get(dev);
  b=but_(c);
  x=x_(c);
  y=y_(c);
#ifndef __GRX_MODE__
  lwp_disable;
  switch (code)
   { case APP_START:
       break;
     case H_MOUSE:
       printf("X: %d, Y: %d, B: %d\n",x,y,b);
       switch (b)
        { case E_LDBL_CLICK: printf(" LEFT DBL_CLICKED\n");
           break;
          case E_L_DOWN: printf(" LEFT PRESSED\n");
           break;
          case E_L_UP: printf(" LEFT RELEASED\n");
           break;
          case E_L_CLICK: printf(" LEFT CLICKED\n");
           break;
          case E_RDBL_CLICK: printf(" RIGHT DBL_CLICKED\n");
           break;
          case E_R_DOWN: printf(" RIGHT PRESSED\n");
           break;
          case E_R_UP: printf(" RIGHT RELEASED\n");
           break;
          case E_R_CLICK: printf(" RIGHT CLICKED\n");
           break;
           case E_MDBL_CLICK: printf(" MID DBL_CLICKED\n");
           break;
          case E_M_DOWN: printf(" MID PRESSED\n");
           break;
          case E_M_UP: printf(" MID RELEASED\n");
           break;
          case E_M_CLICK: printf(" MID CLICKED\n");
           break;
          default:
           if (b&E_L_PRESSED) printf(" LEFT IN PRESSED STATE\n");
           if (b&E_R_PRESSED) printf(" RIGHT IN PRESSED STATE\n");
           if (b&E_M_PRESSED) printf(" MID IN PRESSED STATE\n");
           break;
        }
       fflush(stdout);
     #else
        if (b&E_L_PRESSED)
          { show_mouse(NULL);
            _putpixel(screen,x,y,15);
            _putpixel(screen,x+1,y+1,15);
            _putpixel(screen,x-1,y-1,15);
            _putpixel(screen,x+1,y-1,15);
            _putpixel(screen,x-1,y+1,15);
     //   blit (pcx,screen,0,0,0,0,800,600);
            show_mouse(screen);
          }

     //  putpixel(screen,x,y,15);
     #endif
       break;
     case APP_STOP:
       return(0);
       break;
     default:
       break;
    }
  lwp_enable;
  return(1);
}
#endif

int main(void)
{
  dz_app *keyb_app;
  dz_app *mice_app;
  dz_app *port2_app;
//  dz_app *port1_app;
  comm_port *port;

  clrscr();
//  allegro_init(); //now you should use palantir_init
  if (palantir_init(DEV_KEYBOARD|DEV_MOUSE|DEV_COMMS)==FALSE) return(0);
  LOCK_FUNCTION(com2_wrapper);

#ifdef __DZ_MOUSE_LWP__
  if ((mice_app=dz_app_new("MICE APP",4096,1,mouse_handler))==NULL) exit(255);
  device_client_task_add(mouse_device,mice_app,READ);
#endif

#ifdef __DZ_KEYBOARD_LWP__
  keyb_app=dz_app_new("KBD APP",4096,1,keyboard_handler);
  device_client_task_add(keyboard_device,keyb_app,READ);
#endif

#ifdef __DZ_COMM_LWP__
//------------------- comm2 ---------------------

  if ((port2=comm_port_new(com2,com2_wrapper))==NULL)
   { dz_print_comm_err();
     exit(1);
   }
  port=(comm_port*)(port2->device_user_data);
  strcpy(port2->szName,"COM2-Modem (type command) :");
  port->nBoud=_115200;
  port->control_type=XON_XOFF;
  if (!comm_port_install_handler(port2))
   { dz_print_comm_err();
     exit(1);
   }
  port2_app=dz_app_new("PORT2 APP",4096,1,com2_handler);
  device_client_task_add(port2,port2_app,READ);

/*
//------------------- comm1 ---------------------

  if ((port1=comm_port_new(com1,com1_wrapper))==NULL)
   { dz_print_comm_err();
     exit(1);
   }
  strcpy(port1->szName,"COM1-Mouse");
  if (!comm_port_install_handler(port1))
   { dz_print_comm_err();
     exit(1);
   }

  port1_app=dz_app_new("PORT1 APP",4096,1,com1_handler);
  device_client_task_add(port1,port1_app,READ);
*/
#endif


  #ifdef __GRX_MODE__
  set_screen();
  #endif

  idle_proc_add(show_time);
  printf("Touch keyboard, move mouse, send commands to modem ...\nCtrl-Q to exit\n");
  lwp_wait_true(&exit_program);
  return(0);
}
